<html>
<head>
<title>OgreParticle.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreParticle.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreParticle_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Particle_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Particle_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreBillboard_8h.html">OgreBillboard.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 
<a name="l00051"></a><a class="code" href="classOgre_1_1ParticleVisualData.html">00051</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ParticleVisualData.html" title="Abstract class containing any additional data required to be associated with a particle to perform th...">ParticleVisualData</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">FXAlloc</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053     <span class="keyword">public</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1ParticleVisualData.html#a0b957dd0d6a183e37d2e4c4edc3a08ee">00054</a>         <a class="code" href="classOgre_1_1ParticleVisualData.html#a0b957dd0d6a183e37d2e4c4edc3a08ee">ParticleVisualData</a>() {}
<a name="l00055"></a><a class="code" href="classOgre_1_1ParticleVisualData.html#a2863bf29693feca5637d1baab698c17a">00055</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ParticleVisualData.html#a2863bf29693feca5637d1baab698c17a">~ParticleVisualData</a>() {}
<a name="l00056"></a>00056 
<a name="l00057"></a>00057     };
<a name="l00058"></a>00058 
<a name="l00060"></a><a class="code" href="classOgre_1_1Particle.html">00060</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Particle.html" title="Class representing a single particle instance.">Particle</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">FXAlloc</a>
<a name="l00061"></a>00061     {
<a name="l00062"></a>00062     <span class="keyword">protected</span>:
<a name="l00064"></a><a class="code" href="classOgre_1_1Particle.html#abdb83d31d2f73646b23a82fa8dddb2ef">00064</a>         <a class="code" href="classOgre_1_1ParticleSystem.html" title="Class defining particle system based special effects.">ParticleSystem</a>* <a class="code" href="classOgre_1_1Particle.html#abdb83d31d2f73646b23a82fa8dddb2ef" title="Parent ParticleSystem.">mParentSystem</a>;
<a name="l00066"></a><a class="code" href="classOgre_1_1Particle.html#a6484d779038d54ca579b9939181c6ecf">00066</a>         <a class="code" href="classOgre_1_1ParticleVisualData.html" title="Abstract class containing any additional data required to be associated with a particle to perform th...">ParticleVisualData</a>* <a class="code" href="classOgre_1_1Particle.html#a6484d779038d54ca579b9939181c6ecf" title="Additional visual data you might want to associate with the Particle.">mVisual</a>;
<a name="l00067"></a>00067     <span class="keyword">public</span>:
<a name="l00069"></a><a class="code" href="classOgre_1_1Particle.html#a1c17e03466492e1983a439eb7e540e25">00069</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Particle.html#a1c17e03466492e1983a439eb7e540e25" title="Type of particle.">ParticleType</a>
<a name="l00070"></a>00070         {
<a name="l00071"></a><a class="code" href="classOgre_1_1Particle.html#a1c17e03466492e1983a439eb7e540e25af72cab2ce3d47d8aa4ec32797372bd81">00071</a>             <a class="code" href="classOgre_1_1Particle.html#a1c17e03466492e1983a439eb7e540e25af72cab2ce3d47d8aa4ec32797372bd81">Visual</a>,
<a name="l00072"></a><a class="code" href="classOgre_1_1Particle.html#a1c17e03466492e1983a439eb7e540e25a42e46625a50eb279c03f665fa715d749">00072</a>             Emitter
<a name="l00073"></a>00073         };
<a name="l00074"></a>00074 
<a name="l00076"></a><a class="code" href="classOgre_1_1Particle.html#ac4a7e742d6abd51a9dceaec92eb0e23a">00076</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Particle.html#ac4a7e742d6abd51a9dceaec92eb0e23a" title="Does this particle have it&#39;s own dimensions?">mOwnDimensions</a>;
<a name="l00078"></a><a class="code" href="classOgre_1_1Particle.html#adf524dfe79984bbdeb8130f5c0348fdb">00078</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Particle.html#adf524dfe79984bbdeb8130f5c0348fdb" title="Personal width if mOwnDimensions == true.">mWidth</a>;
<a name="l00080"></a><a class="code" href="classOgre_1_1Particle.html#a93027e6a8be2be918488edf6c88217c0">00080</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Particle.html#a93027e6a8be2be918488edf6c88217c0" title="Personal height if mOwnDimensions == true.">mHeight</a>;
<a name="l00082"></a><a class="code" href="classOgre_1_1Particle.html#a2d3471733bab703d13c19a7408a09c4c">00082</a>         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> <a class="code" href="classOgre_1_1Particle.html#a2d3471733bab703d13c19a7408a09c4c" title="Current rotation value.">rotation</a>;
<a name="l00083"></a>00083         <span class="comment">// Note the intentional public access to internal variables</span>
<a name="l00084"></a>00084         <span class="comment">// Accessing via get/set would be too costly for 000&#39;s of particles</span>
<a name="l00086"></a><a class="code" href="classOgre_1_1Particle.html#a2e4517ab1b59795b66fef4b8aefbde28">00086</a> <span class="comment"></span>        <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Particle.html#a2e4517ab1b59795b66fef4b8aefbde28" title="World position.">position</a>;
<a name="l00088"></a><a class="code" href="classOgre_1_1Particle.html#ad096a8561ce604af5262b1bb2aeee56a">00088</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Particle.html#ad096a8561ce604af5262b1bb2aeee56a" title="Direction (and speed)">direction</a>;
<a name="l00090"></a><a class="code" href="classOgre_1_1Particle.html#af0a9c1c6fed9b18ff0f0c6d27fe67e23">00090</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1Particle.html#af0a9c1c6fed9b18ff0f0c6d27fe67e23" title="Current colour.">colour</a>;
<a name="l00092"></a><a class="code" href="classOgre_1_1Particle.html#a11f740b29bc51425c987632d037e3da9">00092</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Particle.html#a11f740b29bc51425c987632d037e3da9" title="Time to live, number of seconds left of particles natural life.">timeToLive</a>;
<a name="l00094"></a><a class="code" href="classOgre_1_1Particle.html#a50c7f1900cf53966599cd9ad53c9b199">00094</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Particle.html#a50c7f1900cf53966599cd9ad53c9b199" title="Total Time to live, number of seconds of particles natural life.">totalTimeToLive</a>;
<a name="l00096"></a><a class="code" href="classOgre_1_1Particle.html#a6c340715b6b34951ac5b09ece49a93f1">00096</a>         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> <a class="code" href="classOgre_1_1Particle.html#a6c340715b6b34951ac5b09ece49a93f1" title="Speed of rotation in radians/sec.">rotationSpeed</a>;
<a name="l00098"></a><a class="code" href="classOgre_1_1Particle.html#a193b1bf36fb1fae4ed7f2a24dc6b50bd">00098</a>         <a class="code" href="classOgre_1_1Particle.html#a1c17e03466492e1983a439eb7e540e25" title="Type of particle.">ParticleType</a> <a class="code" href="classOgre_1_1Particle.html#a193b1bf36fb1fae4ed7f2a24dc6b50bd" title="Determines the type of particle.">particleType</a>;
<a name="l00099"></a>00099 
<a name="l00100"></a><a class="code" href="classOgre_1_1Particle.html#ac8af4974850cd869b3f2331927dce745">00100</a>         <a class="code" href="classOgre_1_1Particle.html" title="Class representing a single particle instance.">Particle</a>()
<a name="l00101"></a>00101             : mParentSystem(0), mVisual(0), mOwnDimensions(false), rotation(0), 
<a name="l00102"></a>00102             position(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO), direction(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO), 
<a name="l00103"></a>00103             colour(<a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>::White), timeToLive(10), totalTimeToLive(10), 
<a name="l00104"></a>00104             rotationSpeed(0), particleType(Visual)
<a name="l00105"></a>00105         {
<a name="l00106"></a>00106         }
<a name="l00107"></a>00107 
<a name="l00115"></a>00115         <span class="keywordtype">void</span> setDimensions(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height); 
<a name="l00116"></a>00116 
<a name="l00122"></a><a class="code" href="classOgre_1_1Particle.html#a8f4a78d8b0adf3475c34f8f5627d13cd">00122</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Particle.html#a8f4a78d8b0adf3475c34f8f5627d13cd" title="Returns true if this particle deviates from the ParticleSystem&#39;s default dimensions (i...">hasOwnDimensions</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOwnDimensions; }
<a name="l00123"></a>00123 
<a name="l00125"></a><a class="code" href="classOgre_1_1Particle.html#a5290732791067176c46213f202e7c825">00125</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Particle.html#a5290732791067176c46213f202e7c825" title="Retrieves the particle&#39;s personal width, if hasOwnDimensions is true.">getOwnWidth</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mWidth; }
<a name="l00126"></a>00126 
<a name="l00128"></a><a class="code" href="classOgre_1_1Particle.html#ae3cbb490ad08cdee104e99757fe950a6">00128</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Particle.html#ae3cbb490ad08cdee104e99757fe950a6" title="Retrieves the particle&#39;s personal width, if hasOwnDimensions is true.">getOwnHeight</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHeight; }
<a name="l00129"></a>00129         
<a name="l00131"></a>00131         <span class="keywordtype">void</span> setRotation(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rad);
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classOgre_1_1Particle.html#a7b0d81161cc9001be6d9d5f6014ef0a7">00133</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; <a class="code" href="classOgre_1_1Particle.html#a7b0d81161cc9001be6d9d5f6014ef0a7">getRotation</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> rotation; }
<a name="l00134"></a>00134 
<a name="l00137"></a>00137         <span class="keywordtype">void</span> _notifyOwner(<a class="code" href="classOgre_1_1ParticleSystem.html" title="Class defining particle system based special effects.">ParticleSystem</a>* owner);
<a name="l00138"></a>00138 
<a name="l00141"></a><a class="code" href="classOgre_1_1Particle.html#adbb195c8ac77dac1051a927d744034a5">00141</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Particle.html#adbb195c8ac77dac1051a927d744034a5" title="Internal method for notifying the particle of it&#39;s optional visual data.">_notifyVisualData</a>(<a class="code" href="classOgre_1_1ParticleVisualData.html" title="Abstract class containing any additional data required to be associated with a particle to perform th...">ParticleVisualData</a>* vis) { mVisual = vis; }
<a name="l00142"></a>00142 
<a name="l00144"></a><a class="code" href="classOgre_1_1Particle.html#abcc488e921cb51541564743724b45cba">00144</a>         <a class="code" href="classOgre_1_1ParticleVisualData.html" title="Abstract class containing any additional data required to be associated with a particle to perform th...">ParticleVisualData</a>* <a class="code" href="classOgre_1_1Particle.html#abcc488e921cb51541564743724b45cba" title="Get the optional visual data associated with the class.">getVisualData</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVisual; }
<a name="l00145"></a>00145 
<a name="l00147"></a>00147         <span class="keywordtype">void</span> resetDimensions(<span class="keywordtype">void</span>);
<a name="l00148"></a>00148     };
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <span class="preprocessor">#endif</span>
<a name="l00154"></a>00154 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
